
%this is for case #1. BER as a function of alpa_00 and alpha_01. solve BER
%with double integral. Let bt/b=0.9. No Noise

function Figure2_1 

   
clear all;
close all;

flag =0; %set this 1 to get experimental values
beta = 50;
s = 40;
b = sqrt(2)/2;
bt = 0.9*b;

maxx = int_up_lim(b,bt);

%get the theoritical values(Average)to y1-y3 and get the gaussian
%approximated values to g1-g3
 vec_N=8:4:24;
 k=1;
 for j=1:length(vec_N),
    N =vec_N(j);
    y1(k) = quad(@(x)intfun(x,N,beta,s,1,b,bt),0,maxx);
    y2(k) = quad(@(x)intfun(x,N,beta,s,20,b,bt),0,maxx);
    y3(k) = quad(@(x)intfun(x,N,beta,s,39,b,bt),0,maxx);
 
    g1(k) = gauss_approx(N,beta,s,1,b,bt);
    g2(k) = gauss_approx(N,beta,s,20,b,bt);
    g3(k) = gauss_approx(N,beta,s,39,b,bt);
    k=k+1;
 
 end
 
 switch flag
     case 1
        [y4,y5,y6]=experimental;    %call the function which calculates BER based on simulation
     case 0
        load('y4.mat'); % simulated BER for tau=1
        load('y5.mat'); % simulated BER for tau=20
        load('y6.mat'); % simulated BER for tau=39
 end
 
 figure
 semilogy(vec_N,y1,'-ko',vec_N,y2,'-ro',vec_N,y3,'-bo',vec_N,y4,':k*',vec_N,y5,':r*',vec_N,y6,':b*',vec_N,g1,'^k--',vec_N,g2,'^r--',vec_N,g3,'^b--'),axis([8 24 0 0.15]) 
 title('BER Vs N for various delays \tau')
 xlabel('N')
 ylabel('BER')
 legend('\tau = 1 (th)','\tau = 20 (th)', '\tau =39 (th)', '\tau = 1 (exp)','\tau = 20 (exp)', '\tau =39 (exp)','\tau = 1 (app)','\tau = 20 (app)', '\tau =39 (app)','Location','NorthEastOutside')
 saveas(gcf,'BER_Vs_N_Figure2_1','epsc')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y = intfun1(x,b,bt)

y = (2.*x.*b^2.*bt^2)./(x.^2.*bt^2+b^2).^2;   %pdf of r 

end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y = intfun(x,N,beta,s,tau,b,bt)

T1 = (N/beta)./((s/tau).*(x+1)-1).^2;   %x=Rayleigh parameter r
T2 = ((beta-1)/beta^2)./((s/tau).*(x+1)-1);
T3 = (2*N-1)/2/beta;

xi = T1+T2+T3;
y1 = erfc(xi.^(-1/2))/2;
y2 = (2.*x.*b^2.*bt^2)./(x.^2.*bt^2+b^2).^2;
y = (y1.*y2);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function maxx = int_up_lim(b,bt)

MAX_I = 10^6; 
step = 10^(-2);
MAX_CDF = 0.99999;

maxx = b/sqrt(3)/bt;
no_it = 1;
while no_it<MAX_I,
     maxx = maxx+step;
     if( quad(@(x)intfun1(x,b,bt),0,maxx)>=MAX_CDF ),
        break;   
     else
        no_it=no_it+1;
    end    
end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Calculate GAUSSIAN appriximated values
function ABER = gauss_approx(N,beta,s,tau,b,bt)

%Compute E[z^2]
Ealz = b*(pi/2)^(1/2);
Ealz_2 = 2*b^2;
Ealo = bt*(pi/2)^(1/2);
Ealo_2 = 2*bt^2;

EA_2 = (1/4)*N*(2*beta) + (1/4)*(2*beta)^2 - (1/8)*(2*beta);
EB_2 = (1/4)*N*(2*beta);
EAB = (1/8)*(2*beta-2);

T1 = ( s^2*Ealz_2 + (s-tau)^2*Ealo_2 + 2*s*(s-tau)*Ealz*Ealo )*EA_2;
T2 = tau^2*Ealo_2*EB_2;
T3 = 2*tau*( s*Ealz*Ealo + (s-tau)*Ealo_2 )*EAB;

Ez_2 = T1 + T2 + T3;

%Compute E[z]
Ez = (pi/2)^(1/2)*( b*s+bt*(s-tau) )*beta;

%Compute zeta
zeta = 2*Ez_2/Ez^2 - 2;

%Compute approx. BER
ABER = erfc(zeta^(-1/2))/2;

end

