
%calculate BER for the simulated data points. Case2

function [y4,y5,y6]=experimental
disp('experimental results')

clear all
close all

N=4;
beta = 50;
s = 40;
tau = 1;
r0 = 1.1;
b = sqrt(2)/2;
Ntr=10^6;
    
y4=zeros(8,1);   %stores BER when tau=1
y5=zeros(8,1);   %stores BER when tau=20
y6=zeros(8,1);   %stores BER when tau=39
         
    
vec_SNR=1:1:8;
k=1;
for j=1:length(vec_SNR),
    N0 =  beta./(10^(vec_SNR(j)/10));
    % calculate BER when tau =1
       vecErr = recieved(Ntr,N,beta,b,r0,s,1,N0);
       fprintf('N0=%10.8f tau=%2i BER=%2.4f\n',N0,1,sum(vecErr)/Ntr);
       y4(k)= sum(vecErr)/Ntr;
       save('y4','y4');
    
    % calculate BER when tau =20
        vecErr = recieved(Ntr,N,beta,b,r0,s,20,N0);
        fprintf('N0=%10.8f tau=%2i BER=%2.4f\n',N0,20,sum(vecErr)/Ntr);
        y5(k)= sum(vecErr)/Ntr;
        save('y5','y5');
    
    % calculate BER when tau =39
        vecErr = recieved(Ntr,N,beta,b,r0,s,39,N0);
        fprintf('N0=%10.8f tau=%2i BER=%2.4f\n',N0,39,sum(vecErr)/Ntr);
        y6(k)= sum(vecErr)/Ntr;
        save('y6','y6');
    
        k=k+1;
end
   
end



function vecErr = recieved(Ntr,N,beta,b,r0,s,tau,N0)


vecErr = zeros(Ntr,1);

for i=1:Ntr, %for Ntr no. of bits, repeats the same process 
    
    
H = 2*beta;
U = zeros(H,N);

    for n=1:N,
    x = randraw('u', [], 1);
    U(:,n) = gencode(x,H);
    end

%calculate term A and associated coefficients
A = sum(U'*U(:,1));
al_00 = randraw('rayl', b, 1);
al_01 = al_00/r0;
T1=(al_00*s+al_01*(s-tau))*A;

%calculate term B and associated coefficient
U1 = [U(end,:); U(1:end-1,:)];
%display(U1)
B = sum(U1'*U(:,1));
T2=al_01*tau*B;


%calculate term C and associated coefficient
xi = randraw('norm',[],H)*sqrt(N0);

C=xi'*U(:,1);
T3=s*C;

Z= T1+T2+T3;
if Z<0
    vecErr(i)=1 ;
end

end

end

%Generate chaotic sequence of length =100bits
function ucode = gencode(x,H)
    ucode = zeros(H,1);
    ucode(1) = x;
    for i=2:H,
        ucode(i) = 1-2*(ucode(i-1))^2;
    end
end



