%calculate BER for the simulated data points

function [y4,y5,y6]=experimental
disp('experimental results')
clear all
close all

beta = 50;
s = 40;
b = sqrt(2)/2;
bt=0.9*b;
N0 = 50/10^0.2;        %E_b/N_0= 2dB
Ntr=10^6;
    
y4=zeros(6,1);   %stores BER when tau=1
y5=zeros(6,1);   %stores BER when tau=20
y6=zeros(6,1);   %stores BER when tau=39
    
         
k=1;
        
for N=4:4:24
       
    % calculate BER when tau =1
      vecErr = recieved(Ntr,N,beta,b,bt,s,1,N0);
      fprintf('N=%2i tau=%2i BER=%2.4f \n',N,1,sum(vecErr)/Ntr);
      y4(k)= sum(vecErr)/Ntr;
      save('y4','y4');
    
    % calculate BER when tau =20
      vecErr = recieved(Ntr,N,beta,b,bt,s,20,N0);
      fprintf('N=%2i tau=%2i BER=%2.4f \n',N,20,sum(vecErr)/Ntr);
      y5(k)= sum(vecErr)/Ntr;
      save('y5','y5');
    
    % calculate BER when tau =39
      vecErr = recieved(Ntr,N,beta,b,bt,s,39,N0);
      fprintf('N=%2i tau=%2i BER=%2.4f \n',N,39,sum(vecErr)/Ntr);
      y6(k)= sum(vecErr)/Ntr;
      save('y6','y6');
    
      k=k+1;
end
   


end



function vecErr = recieved(Ntr,N,beta,b,bt,s,tau,N0)


vecErr = zeros(Ntr,1);

for i=1:Ntr, %for Ntr no. of bits, repeats the same process 
    
    
H = 2*beta;
U = zeros(H,N);

    for n=1:N,
    x = randraw('u', [], 1);
    U(:,n) = gencode(x,H);
    end

%calculate term A and associated coefficients
A = sum(U'*U(:,1));
al_00 = randraw('rayl', b, 1);
al_01 = randraw('rayl', bt, 1);
T1=(al_00*s+al_01*(s-tau))*A;

%calculate term B and associated coefficient
U1 = [U(end,:); U(1:end-1,:)];
%display(U1)
B = sum(U1'*U(:,1));
T2=al_01*tau*B;


%calculate term C and associated coefficient
xi = randraw('norm',[],H)*sqrt(N0);

C=xi'*U(:,1);
T3=s*C;

Z= T1+T2+T3;
if Z<0
    vecErr(i)=1 ;
end

end

end

%Generate chaotic sequence of length =100bits
function ucode = gencode(x,H)
    ucode = zeros(H,1);
    ucode(1) = x;
    for i=2:H,
        ucode(i) = 1-2*(ucode(i-1))^2;
    end
end



