
%this is for case #3. BER as a function of alpa_00 and alpha_01. solve BER
%with double integral. Let bt/b=0.9

function Figure2_6         

clear all;
close all;

flag =0; %set this 1 to get experimental values
N = 4;
beta = 50;
s = 40;
b = sqrt(2)/2;
bt = 0.9*b;


%Integration upper limit
[maxx maxy] = int_up_lim(b,bt);


%get the theoritical values(Average)to y1-y3 and get the gaussian
%approximated values to g1-g3
 vec_SNR = 1:1:8;
 k=1;
 for j=1:length(vec_SNR),
   N0 =  beta./(10^(vec_SNR(j)/10));
   y1(k) = quad2d(@(x,y)intfun(x,y,N,beta,s,1,N0,b,bt),0,maxx,0,maxy);
   y2(k) = quad2d(@(x,y)intfun(x,y,N,beta,s,20,N0,b,bt),0,maxx,0,maxy);
   y3(k) = quad2d(@(x,y)intfun(x,y,N,beta,s,39,N0,b,bt),0,maxx,0,maxy);
 
   g1(k) = gauss_approx(N,beta,s,1,N0,b,bt);
   g2(k) = gauss_approx(N,beta,s,20,N0,b,bt);
   g3(k) = gauss_approx(N,beta,s,39,N0,b,bt);
  
   k=k+1;
 
 end
 
  switch flag
     case 1
        [y4,y5,y6]=experimental;    %call the function which calculates BER based on simulation
     case 0
        load('y4.mat'); % simulated values for tau=1
        load('y5.mat'); % simulated values for tau=20
        load('y6.mat'); % simulated values for tau=39
  end
 
 figure
 
 plot(vec_SNR,y1,'-ko',vec_SNR,y2,'-ro',vec_SNR,y3,'-bo',vec_SNR,y4,':k*',vec_SNR,y5,':r*',vec_SNR,y6,':b*',vec_SNR,g1,'^k--',vec_SNR,g2,'^r--',vec_SNR,g3,'^b--'),axis([1,8,0,0.2])
 title('BER Vs SNR for various delays \tau')
 xlabel('E_b/N_0(dB)')
 ylabel('BER')
 legend('\tau = 1 (th)','\tau = 20 (th)', '\tau =39 (th)', '\tau = 1 (exp)','\tau = 20 (exp)', '\tau =39 (exp)','\tau = 1 (app)','\tau = 20 (app)', '\tau =39 (app)','Location','NorthEastOutside')
 saveas(gcf,'BER_Vs_SNR_Figure2_6','epsc')
end


function z = intfun(x,y,N,beta,s,tau,N0,b,bt)

delta0 = x*s + y*(s-tau);           %x=alpha_00, y=alpha_01
delta1 = y*tau;
rat = delta1./delta0;
T1 = (rat.^2)*(N/beta) + rat*((beta-1)/beta^2) + (2*N-1)/2/beta;
T2 = (1./delta0).^2*N0*(2*s^2/beta);
xi = T1+T2;                         
z1 = erfc(xi.^(-1/2))/2;
z2 = (x./b^2).*exp((-x.^2)./(2*b^2));
z3 = (y./bt^2).*exp((-y.^2)./(2*bt^2));
z = (z1.*z2).*z3;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [maxx maxy] = int_up_lim(b,bt)

MAX_I = 10^6; 
step = 10^(-2);
MAX_CDF = 0.99999;

maxx = b;
maxy = bt;
no_it = 1;
while no_it<MAX_I,
     maxx = maxx+step;
     maxy = maxy+step;
     if( quad2d(@(x,y)intfun1(x,y,b,bt),0,maxx,0,maxy)>=MAX_CDF ),
        break;   
     else
        no_it=no_it+1;
    end    
end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function z = intfun1(x,y,b,bt)

z1 = (x./b^2).*exp((-x.^2)./(2*b^2));
z2 = (y./bt^2).*exp((-y.^2)./(2*bt^2));
z = z1.*z2;

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculate GAUSSIAN approximated values
function ABER = gauss_approx(N,beta,s,tau,N0,b,bt)

%Compute E[z^2]
Ealz = b*(pi/2)^(1/2);
Ealz_2 = 2*b^2;
Ealo = bt*(pi/2)^(1/2);
Ealo_2 = 2*bt^2;

EA_2 = (1/4)*N*(2*beta) + (1/4)*(2*beta)^2 - (1/8)*(2*beta);
EB_2 = (1/4)*N*(2*beta);
EAB = (1/8)*(2*beta-2);

T1 = ( s^2*Ealz_2 + (s-tau)^2*Ealo_2 + 2*s*(s-tau)*Ealz*Ealo )*EA_2;
T2 = tau^2*Ealo_2*EB_2;
T3 = 2*tau*( s*Ealz*Ealo + (s-tau)*Ealo_2 )*EAB;
T4 = s^2*N0*beta;

Ez_2 = T1 + T2 + T3 + T4;

%Compute E[z]
Ez = (pi/2)^(1/2)*( b*s+bt*(s-tau) )*beta;

%Compute zeta
zeta = 2*Ez_2/Ez^2 - 2;

%Compute approx. BER
ABER = erfc(zeta^(-1/2))/2;

end




