%calculate BER for the simulated data points

function experimental1

clear all
close all

N = 4;
beta = 50;
s = 40;
vec_SNR = 1:8;
vec_N0 = beta./(10.^(vec_SNR/10));
b = sqrt(2)/2;
bt=0.9*b;
Ntr=10^6;

    
BER=zeros(length(vec_SNR),1);
tau_counter=zeros(length(vec_SNR),s);
      
 for j=1:length(vec_SNR),
     N0 = vec_N0(j);
     SNR = vec_SNR(j);
         
      % calculate BER
       vecErr = recieved(Ntr,N,beta,b,bt,s,N0);
       fprintf('SNR=%2i N0=%10.8f BER=%2.4f\n',SNR,N0,sum(vecErr)/Ntr);
       BER(j)= sum(vecErr)/Ntr;
       save('BER1','BER1');
       
       %update tau counter
       load('vecTau_count');
       tau_counter(j,:)=vecTau_count;
       save('tau_counter','tau_counter');
 end;
  
  
 end



function vecErr = recieved(Ntr,N,beta,b,bt,s,N0)
lambda = 1/5;
vecErr = zeros(Ntr,1);
vecTau_count = zeros(1,s);

for i=1:Ntr, %Repeats the same process for Ntr no. of bits
 %load('vecTau_count');   
   
 tau_c = randraw('exp', lambda, 1);
 tau_q = floor(tau_c);
 tau = mod (tau_q,s);
 
 %count occurance of each tau values for given SNR
 vecTau_count(tau+1)=vecTau_count(tau+1)+1;
 
 H = 2*beta;
 U = zeros(H,N);

    for n=1:N,
    x = randraw('u', [], 1);
    U(:,n) = gencode(x,H);
    end

%calculate term A and associated coefficients
A = sum(U'*U(:,1));
al_00 = randraw('rayl', b, 1);
al_01 = randraw('rayl', bt, 1);
T1=(al_00*s+al_01*(s-tau))*A;

%calculate term B and associated coefficient
U1 = [U(end,:); U(1:end-1,:)];
%display(U1)
B = sum(U1'*U(:,1));
T2=al_01*tau*B;


%calculate term C and associated coefficient
xi = randraw('norm',[],H)*sqrt(N0);

C=xi'*U(:,1);
T3=s*C;

Z= T1+T2+T3;
if Z<0
    vecErr(i)=1 ;
end


end

save('vecTau_count','vecTau_count');
disp(vecTau_count)
end


%Generate chaotic sequence of length =100bits
function ucode = gencode(x,H)
    ucode = zeros(H,1);
    ucode(1) = x;
    for i=2:H,
        ucode(i) = 1-2*(ucode(i-1))^2;
    end
end



