function Generate_Fig_E_tau_tauc

close all
clear all

s = 40;
vec_inv_lambda = (1:20);
vec_lambda = 1./vec_inv_lambda;
vec_ell = exp(-vec_lambda);
vec_Etau = zeros(size(vec_ell));
vec_Etau2 = zeros(size(vec_ell));


for i=1:length(vec_lambda),
   % lambda = vec_lambda(i);
   ell = vec_ell(i);
   
   [Etau,Etau2] = comp_sum_tau(s,ell);
   [Etau_2,Etau2_2] = comp_tau(s,ell);
   
   if max(abs(Etau-Etau_2),abs(Etau2-Etau2_2)) > 10^(-6),
       fprintf('ERROR!\n');
       pause
   end
   
   vec_Etau(i) = Etau_2;
   vec_Etau2(i) = Etau2_2;
   
end

figure
subplot(1,2,1)
plot(vec_inv_lambda, vec_Etau, 'ko-', ...
    vec_inv_lambda, vec_inv_lambda, 'k*-');
ylabel('Moments \tau, \tau_c');
xlabel('1/\lambda');
legend('E[\tau]','E[\tau_c]','Location','NorthWest');
subplot(1,2,2)    
plot(vec_inv_lambda, vec_Etau2, 'ko-', ...
    vec_inv_lambda, 2*(vec_inv_lambda.^2), 'k*-');
xlabel('1/\lambda');
legend('E[\tau^2]','E[\tau_c^2]','Location','NorthWest');

% figure
% plot(vec_inv_lambda, vec_Etau, 'ro-', ...
%     vec_inv_lambda, vec_Etau2, 'r--', ...
%     vec_inv_lambda, vec_inv_lambda, 'ko-', ...
%     vec_inv_lambda, 2*(vec_inv_lambda.^2), 'k--');
% legend('E[\tau]','E[\tau^2]','E[\tau_c]','E[\tau_c^2]');
% 
% figure
% plot(vec_lambda, vec_Etau, 'ro-', ...
%     vec_lambda, vec_Etau2, 'r--', ...
%     vec_lambda, vec_inv_lambda, 'ko-', ...
%     vec_lambda, 2*(vec_inv_lambda.^2), 'k--');
% legend('E[\tau]','E[\tau^2]','E[\tau_c]','E[\tau_c^2]');

end

function [Etau,Etau2] = comp_sum_tau(s,ell)

Etau = 0;
Etau2 = 0;
for k=1:s-1,
    Etau = Etau + k*ell^k;
    Etau2 = Etau2 + k^2*ell^k;
end
Etau = (1-ell)/(1-ell^s)*Etau;
Etau2 = (1-ell)/(1-ell^s)*Etau2;

end

function [Etau_2,Etau2_2] = comp_tau(s,ell)

Etau_2 = (ell/(1-ell^s))*((s-1)*ell^s-s*ell^(s-1)+1)/(1-ell);

Etau2_2 = Etau_2 + (ell^2/(1-ell^s))*(2*(1-ell^s)/(1-ell)^2-2*ell^(s-1)*s/(1-ell)-ell^(s-2)*s*(s-1));

end



